from ginkgo.dao import datamanager
import httplib2
import os
import time
import re

from PyKDE4.nepomuk import Nepomuk
from PyQt4.QtCore import QUrl
from ginkgo.ontologies import NFO, NIE, PIMO, NCO, TMO
from urllib import urlencode
from urllib import quote

def read_as_string(file):
    # read the file
    f = open(file, "r")
    content = f.read()
    f.close()
    return content


def importNotes(root):
    counter = 0
    newResources = []
    oldResources = []

    for filename in os.listdir(root):
        filepath = os.path.join(root, filename)
        if os.path.isfile(filepath):
                counter += 1
                pcontent = read_as_string(filepath)
                pcontent = pcontent.replace("%Types", "")
                pcontent = pcontent.replace("[[FrNet]]", "")
                pcontent = pcontent.replace("[FrNet]", "")
                content = ""
                lineCounter = 0
                for line in pcontent.split("\n"):
                    if lineCounter == 0 and line.find("1:") == 0:
                        lineCounter += 1
                        continue
                    content = content+line+"\n"
                    lineCounter += 1
                content = content.strip()

                

                res = datamanager.findResourceByLabel(filename, match=Nepomuk.Query.ComparisonTerm.Equal)
                if not res:
                    #newWord = datamanager.createResource(filename, QUrl("nepomuk:/res/c7f1509b-3eaa-4127-b28f-42f459678bcb"))

                    newWord = datamanager.createResource(filename, QUrl("nepomuk:/res/36e59e2e-409a-40a8-9175-c929792383d2"))
                    try:
                        newWord.setDescription(unicode(content))
                    except Exception, e:
                        print filename
                        print e

                    newResources.append(filename)

                else:
#                    print filename
#                    print res.genericLabel()
                    #oldResources.append(res.genericLabel())
                    oldResources.append(filename)
                
                #print oldResources
    
    
    print len(newResources)
    print len(oldResources)
    print counter
    



def importTypeInstancesToXWiki(typeUri):
    queryString = "select distinct ?r  where { ?r a ?v1 . ?v1 <http://www.w3.org/2000/01/rdf-schema#subClassOf> <%s> .   }" % typeUri
    resources = datamanager.sparqlToResources(queryString)
    counter = 0
    for resource in resources:
        counter += 1
        if counter < 5:
            toXWikiPage(resource)
            
            

def checkPageExists(resource):
    h = httplib2.Http(".cache")
    label = unicode(resource.genericLabel())
    
    resp, content = h.request("http://xwiki:8080/xwiki/rest/wikis/beagle/spaces/wiki/pages/%s" % quote(label), "GET")
    idx = content.find("<?xml")
    if idx == 0:
        return True
    else:
        return False
        
def toXWikiPage(resource):
        
    h = httplib2.Http(".cache")
    #h.add_credentials('Admin', 'admin')
    
    
    pageExists = checkPageExists(resource)
    
    if pageExists:
        label = unicode(resource.genericLabel())
        data = dict(content= unicode(resource.description()), title = label)
        
        print label
    
        resp, content = h.request("http://xwiki:8080/xwiki/rest/wikis/beagle/spaces/wiki/pages/%s" % quote(label),
                              "PUT", urlencode(data),
                              headers={'content-type':'application/x-www-form-urlencoded'})
        print "Response: %s" % resp
    
        url = resource.property(NIE.url).toString()
        
        ttypes = []
        xtypes = ["Software","Organization","Person","Project","Web page","Word","Mot","Article","Book","Conference","Poem","Song","Quotation","Region","Country","City","Topic","Diary"]
        
        for rtype in resource.types():
            atype = Nepomuk.Types.Class(rtype)
            atypeLabel = atype.label("en")
            print atypeLabel
            try:
                idx = xtypes.index(atypeLabel)
                ttypes.append(unicode(atype.label("en")))
            except:
                print "-> error"
                pass
        
        ttypesStr = ",".join(ttypes)
                
        data = dict({"className":"wiki.Resource", "property#types": ttypesStr, "property#url":url})
            
        resp, content = h.request("http://xwiki:8080/xwiki/rest/wikis/beagle/spaces/wiki/pages/%s/objects" % quote(label),
                              "POST", urlencode(data),
                              headers={'content-type':'application/x-www-form-urlencoded'})
        print "Response: %s" % resp


def importToXWiki(pcontent, filename):
    data = dict(content= pcontent)
    h = httplib2.Http(".cache")
    h.add_credentials('Admin', 'admin')
    resp, content = h.request("http://xwiki:8080/xwiki/rest/wikis/xwiki/spaces/wiki/pages/" + quote(filename),
                          "PUT", urlencode(data),
                          headers={'content-type':'application/x-www-form-urlencoded'})
    print "Response: %s" % resp


if __name__ == "__main__":
    importTypeInstancesToXWiki("http://www.semanticdesktop.org/ontologies/2007/11/01/pimo#Project")

